package ru.ldeloff.servermonitorbot.config;

import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;
import ru.ldeloff.servermonitorbot.model.user.User;
import ru.ldeloff.servermonitorbot.service.RoleService;

import java.util.List;

@Component
@ConfigurationProperties(prefix = "bot")
@Getter
@Setter
public class UserConfig {

    private List<UserProperty> users;

    @Autowired
    private RoleService roleService;

    @Getter
    @Setter
    public static class UserProperty {
        private Long telegramId;
        private String role;
    }

    public List<User> getUsers() {
        return users.stream().map(user -> new User()
                .setTelegramId(user.getTelegramId())
                .setRole(roleService.findRoleByName(user.getRole()))
        ).toList();
    }

}
