package ru.ldeloff.servermonitorbot.init;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import ru.ldeloff.servermonitorbot.config.UserConfig;
import ru.ldeloff.servermonitorbot.service.UserService;

@Slf4j
@Component
@RequiredArgsConstructor
@Order(2)
public class AddUsers implements ApplicationRunner {

    final UserConfig userConfig;
    final UserService userService;

    @Override
    public void run(ApplicationArguments args) {
        userConfig.getUsers().forEach(userService::saveOrUpdateUser);
        log.info("Загружены и обновлены пользователи");
    }
}
