package ru.ldeloff.servermonitorbot.repository;

import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Repository;
import ru.ldeloff.servermonitorbot.model.server.SshServer;

@Repository
@RequiredArgsConstructor
public class SshRepositoryImpl implements SshRepository {

    @Value("${ssh.timeout:5000}")
    private int TIMEOUT;

    @Override
    public void connect(SshServer sshServer) throws JSchException {
        Session session = new JSch().getSession(sshServer.getUser(),
                sshServer.getHost(),
                sshServer.getPort());
        session.setPassword(sshServer.getPassword());
        session.setConfig("StrictHostKeyChecking", "no");
        session.setTimeout(TIMEOUT);

        session.connect();

        sshServer.setSession(session);
    }

    @Override
    public void disconnect(SshServer sshServer) {
        sshServer.getSession().disconnect();
    }

}
