package ru.ldeloff.servermonitorbot.service;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import org.telegram.telegrambots.meta.exceptions.TelegramApiException;
import ru.ldeloff.servermonitorbot.controller.TelegramBotController;


@Slf4j
@Service
@RequiredArgsConstructor
public class MessagingServiceImpl implements MessagingService {

    private final UserService userService;
    private final ApplicationContext applicationContext;

    @Override
    public void sendMessageToAdmins(String message) {
        userService.getAllAdmins().forEach(user -> {
            SendMessage sendMessage = new SendMessage();
            sendMessage.setChatId(user.getTelegramId());
            sendMessage.setText(message);
            send(sendMessage);
        });
    }

    @Override
    public void send(SendMessage message) {
        try {
            applicationContext.getBean(TelegramBotController.class).execute(message);
        } catch (TelegramApiException e) {
            log.warn("Ошибка при отправке сообщения", e.getMessage());
        }
    }
}
