package ru.ldeloff.servermonitorbot.service;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import ru.ldeloff.servermonitorbot.model.user.Role;
import ru.ldeloff.servermonitorbot.model.user.User;
import ru.ldeloff.servermonitorbot.model.user.Users;

import java.util.List;

@Slf4j
@Service
@RequiredArgsConstructor
public class UserServiceImpl implements UserService {

    private final Users users;

    @Override
    public void saveOrUpdateUser(User user) {
        if (getByTelegramId(user.getTelegramId()) == null) {
            users.getUsers().add(user);
        }
    }

    @Override
    public User getByTelegramId(Long telegramId) {
        return users.getUsers().stream()
                .filter(user -> user.getTelegramId().equals(telegramId))
                .findFirst()
                .orElse(null);
    }

    @Override
    public List<User> getAllUsers() {return users.getUsers(); }

    @Override
    public List<User> getAllAdmins() {
        return users.getUsers().stream().filter(user -> user.getRole().equals(Role.ADMIN)).toList();
    }

}
