package ru.ldeloff.servermonitorbot.view;

import org.springframework.stereotype.Service;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import ru.ldeloff.servermonitorbot.commands.CommandTemplate;
import ru.ldeloff.servermonitorbot.service.MessagingService;
import ru.ldeloff.servermonitorbot.util.UpdateUtil;
import ru.ldeloff.servermonitorbot.model.user.User;
import ru.ldeloff.servermonitorbot.service.SshService;

@Service
public class FirstUseCommand extends CommandTemplate {

    private final TelegramBotKeyboard telegramBotKeyboard;

    public FirstUseCommand(UpdateUtil updateUtil, ServerListButtons serverListButtons, SshService sshService, TelegramBotKeyboard telegramBotKeyboard, MessagingService messagingService) {
        super(updateUtil, serverListButtons, sshService, messagingService);
        this.telegramBotKeyboard = telegramBotKeyboard;
        setName("/start");
    }


    @Override
    public SendMessage executeAggregate(User user, SendMessage message) {
        message.setText("Добро пожаловать " + user.getLogin() + "!");
        return telegramBotKeyboard.uiForm(message);
    }

    @Override
    public String executeCommandSpecificHost(String serverName) {
        return null;
    }
}
