package ru.ldeloff.servermonitorbot.view;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import ru.ldeloff.servermonitorbot.commands.CommandTemplate;
import ru.ldeloff.servermonitorbot.service.MessagingService;
import ru.ldeloff.servermonitorbot.util.UpdateUtil;
import ru.ldeloff.servermonitorbot.model.user.User;
import ru.ldeloff.servermonitorbot.service.SshService;

@Service
@Slf4j
public class SwitchToMainMenu extends CommandTemplate {

    private final TelegramBotKeyboard telegramBotKeyboard;

    public SwitchToMainMenu(UpdateUtil updateUtil, ServerListButtons serverListButtons, SshService sshService, TelegramBotKeyboard telegramBotKeyboard, MessagingService messagingService) {
        super(updateUtil, serverListButtons, sshService, messagingService);
        this.telegramBotKeyboard = telegramBotKeyboard;
        setName("Not found");
    }

    @Override
    public String executeCommandSpecificHost(String serverName) {
        return null;
    }

    @Override
    public SendMessage executeAggregate(User user, SendMessage message) {
        SendMessage answer = new SendMessage();
        answer.setChatId(user.getTelegramId());
        answer.setText("Неверная команда. Попробуем сначала.");
        return telegramBotKeyboard.uiForm(answer);
    }

}
